package ever.pipeline;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.util.HashMap;

import org.apache.commons.io.FileUtils;

import ever.simpleCooking.CookingPipeline;
import ever.generic.CaseLoader;
import ever.workflowRepresentation.Workflow;


public class Main {
	private static String inputPath="";
	private static String outputPath="";
	
	public static FileWriter logger;
	/**
	 * @param args
	 */
	public static void main(String[] args) {
		parseArguments(args);
		try {
			logger = new FileWriter(new File("Extraction.log"));
		} catch (IOException e1) {
			// TODO Auto-generated catch block
			e1.printStackTrace();
		}
		File folder = new File(inputPath);
		File[] fileList=null;
		try {
			fileList = folder.listFiles();
		} catch (NullPointerException e1) {
			// TODO Auto-generated catch block
			System.out.println("Please create input folder");
			System.exit(0);
		}
		
		if(fileList.length==0)
		{
			System.out.println("No input file was found!");
			System.exit(0);
		}
		for (File in : fileList) {
			if(!in.getName().endsWith(".xml"))
				continue;
			
			if (in.getAbsolutePath().contains("&")) {
				String newName = in.getAbsolutePath().replace("&", "");
				try {
					FileUtils.copyFile(in, new File(newName));
				} catch (IOException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}
			}

			if (in.getAbsolutePath().contains("'")) {
				String newName = in.getAbsolutePath().replace("'", "");
				try {
					FileUtils.copyFile(in, new File(newName));
				} catch (IOException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}
				in.delete();
			}
		}
		
		HashMap<Integer,Case> cases = new HashMap<Integer,Case>();
		CaseLoader cl = new CaseLoader();
		for (File f : fileList) {
			
			Case c = new Case();
			c.setName(f.getName());
			String xml="";
			try {
				BufferedReader buffer = new BufferedReader(new FileReader(f));
				String line = buffer.readLine();
				
				while(line!=null)
				{
					xml+=line;
					line=buffer.readLine();
				}				
				buffer.close();
			} catch (FileNotFoundException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			} catch (IOException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
			c.addXmlString(xml);			
			cases.put(c.getId(), c);			
		}
		CookingPipeline cook = new CookingPipeline();
		cook.buildPipeline();
		cook.putCases(cases);
		cook.run();
		cases=(HashMap<Integer, Case>) cook.getCaseMap();
//		ComputerPipeline comp = new ComputerPipeline();
//		comp.buildPipeline();
//		comp.putCases(cases);
//		comp.run();
//		cases=(HashMap<Integer, Case>) comp.getCaseMap();
		for(int i: cases.keySet())
		{
			String name="";
			Workflow w= cases.get(i).getWf();
			try{
				name=cases.get(i).getName();
						
			}
			catch (Exception ex)
			{
				System.out.println("error");
			}
			
			w.exportWfToTree(outputPath+"/"+name);
		}		
		System.out.println("Done");			
	}
	
	private static void parseArguments(String[] args)
	{
		boolean in=false,out=false;
		for(int i=0; i<args.length; i++)
		{
			if(args[i].equals("--input"))
			{
				inputPath=args[i+1];
				in=true;
			}
			
			if(args[i].equals("--output"))
			{
				outputPath=args[i+1];
				out=true;
			}
						
		}
		if(!in|!out)
		{
			System.out.println("Usage: --input <PATH_TO_INPUT_FOLDER> --output <PATH_TO_OUTPUT_FOLDER>");
			System.exit(0);
		}
	}

}
