package ever.pipeline;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileWriter;
import java.io.IOException;
import java.io.InputStreamReader;

import org.apache.commons.io.FileUtils;


/**
 * This class control Sundance via shell script
 * @author Pol Schumacher, Wirtschaftsinformatik, Institut fuer Informatik, Goethe Universitaet Frankfurt
 *
 */
public class SundanceConnector {
	/**
	 * Creates script to call sundance
	 * @param d
	 */
	public static void setUpConnector(String d)
	{
		String command=System.getProperty("user.dir")+"/sundance-v5.1/bin/aslog -d "+d+" -f "+System.getProperty("user.dir")+"/singlePrep.txt \n"				
				+"mv "+System.getProperty("user.dir")+"/singlePrep.txt.aslog " +System.getProperty("user.dir")+"/sundance-v5.1/data/cooking/caseframe.cooking.txt\n"
//				+"mv singlePrep.txt.aslog ./sundance-v5.1/data/"+d+"/caseframe.cooking.txt \n"		
				+System.getProperty("user.dir")+"/sundance-v5.1/bin/nlp -d "+d+" -seg -f "+System.getProperty("user.dir")+"/singlePrep.txt \n"	
				+System.getProperty("user.dir")+"/sundance-v5.1/bin/nlp -d "+d+" -ext -f "+System.getProperty("user.dir")+"/singlePrep.txt \n";
		try { 
			
			System.out.println("Working Directory = " +
	              System.getProperty("user.dir"));
			
			FileWriter writer = new FileWriter(System.getProperty("user.dir")+"/runSundance.sh");
			writer.write(command);		
			writer.close();
			Runtime.getRuntime().exec("chmod 777 "+System.getProperty("user.dir")+"/runSundance.sh");
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}
	public static void run() 
	{
		try {										
			Process proc = Runtime.getRuntime().exec(System.getProperty("user.dir")+"/runSundance.sh");								
			BufferedReader in = new BufferedReader(new InputStreamReader(proc.getInputStream()));
			String line = in.readLine();
			while(line!=null)
			{
				//System.out.println(line);
				line=in.readLine();
			}
			
			
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}
	
	

}
